from datetime import datetime

from atproto.models.AppBskyFeedDefs import BlockedPost, NotFoundPost
from atproto_client.models.app.bsky.feed import get_timeline


class Client:
    app:    AppNamespace

    def get_current_time_iso (self) -> datetime: ...

    def get_post_thread (
            self,
            uri:            str,
            parent_height:  int | None  = None
    ) -> Response: ...

    def get_timeline (self) -> get_timeline.Response: ...

    def follow (self, did: str) -> None: ...

    def like (self, uri: str, cid: str) -> None: ...


class AppNamespace:
    bsky:   AppBskyNamespace


class AppBskyNamespace:
    notification:   AppBskyNotificationNamespace


class AppBskyNotificationNamespace:
    def list_notifications (self) -> Response: ...

    def update_seen (self, seen: dict[str, datetime]) -> None: ...


class Response:
    notifications:  list[Notification]
    thread:         (ThreadViewPost
                     | NotFoundPost
                     | BlockedPost)


class ThreadViewPost:
    pass


class Notification:
    is_read:    bool
    reason:     str
    uri:        str
    author:     ProfileView


class ProfileView:
    did:    str
